;
; AC, le 10/11/2003
;
; Only to quicky check that colors are OK
; This function works if and only if AC_DISPLAY_INIT then
; AC_COLORS_INIT were previously run
;
; Liste des modifications:
; AC le 26/09/2005:
; - ajout des mots-clefs "table_number" et "background"
; - ajout de la boucle sur les 25 vignettes ...
;
; AC le 27/09/2005:
; - affichage en parcourant toutes les couleurs connues
; 
; AC le 11/10/2005:
; - meilleure gestion de la couleur des axes si le fond n'est plus
;   noir
; - ajout d'un affichage des lignes multicolores sur un seul trace.
; - meilleure gestion de la suppression des fenetres ouvertes
; - je decide de renommer ce package de AC_COLORS_TEST en AC_COLORS_DEMO
;
pro AC_COLORS_DEMO, table_number=table_number, background=background, $
                    help=help, test=test, verbose=verbose
;
mess=AC_SETMESSAGES('AC_COLORS_DEMO')
;
if KEYWORD_SET(help) then begin
    print, 'pro AC_COLORS_DEMO, table_number=table_number, background=background, $'
    print,'        help=help, test=test, verbose=verbose'
    print, ''
    print, 'CALLING SEQUENCE : AC_COLORS_DEMO, /verbose, back=!col.w (fond blanc !)'
    return
endif
;
if NOT(AC_COLORS_EXIST(mess)) then return
;
; on a decide de gerer la couleur du fond:
; si le fond est noir, il faut trace des axes blancs.
; sinon (tous les autres cas a ce jour), on trace des axes noirs
;
; par defaut, on est en noir pour les axes
;
if NOT(KEYWORD_SET(background)) then begin
    print, mess.info+'You can change the background color with back=!col.XYZ'
    current_back=!col.d
    current_axis=!col.w
endif else begin
    current_back=background
    if (current_back EQ !col.d) then begin
        current_axis=!col.w
    endif else begin
        current_axis=!col.d
    endelse
endelse
;
; 1er affichage : Affichage global
;
WINDOW, /free, xsize=200, ys=200
TVSCL, DIST(200)
;
; on va accumuler dans ce tableau (a construire)
; les indices des fenetres a detruire a la fin
win_index=!d.window
;
; affichage de toutes les couleurs ayant un alias connu
; (contenu dans !col)
;
nb_colones=6
nb_lignes=!col.nb_colors
if (nb_lignes MOD nb_colones EQ 0) then begin
    nb_lignes=nb_lignes/nb_colones
endif else begin
    nb_lignes=nb_lignes/nb_colones+1
endelse
;
base=100
;
; le 1er PLOT permet de switcher la couleur du fond (background)
;
WINDOW, /free, xsize=nb_colones*base, ysize=nb_lignes*base
win_index=[win_index,!d.window]
!p.multi=[0,nb_colones, nb_lignes]
PLOT, findgen(10), color=!col.indices(0), $
  title='Color '+!col.name(!col.indices(0)), background=current_back
for i=1,!col.nb_colors-1 do begin
    PLOT, findgen(10), color=!col.indices(i), $
      title='Color '+!col.name(!col.indices(i))
endfor
!p.multi=0
;
; 3ieme trace: des lignes horizontales multicolores
;
WINDOW, /free
win_index=[win_index,!d.window]
PLOT, /nodata, FINDGEN(!col.nb_colors)+1, $
  background=current_back, color=current_axis
for ii=0,!col.nb_colors-1 do begin
    AC_LINES, [ii,ii]+1, color=!col.indices(ii), thick=2
endfor
;
if KEYWORD_SET(verbose) then AC_COLORS_INFO
;
; deuxieme trace couvrant toute la gamme (de 10 a 250)
;
exploration=0
if (exploration EQ 1) then begin
    WINDOW, /free, xsize=600, ys=600
    win_index=[win_index,!d.window]
    !p.multi=[0,5,5]
    !p.thick=2
    for i=1,25 do plot, randomu(100,100), color=i*10, background=background
endif
;
AC_DELAIS
;
for ii=0, N_ELEMENTS(win_index)-1 do WDELETE, win_index(ii)
;
end
