;+
; Creation par AC le 05/09/2005 a Paris
;
; Substitut a FINDFILE pour GDL
;
; ceci ne fonctionne pour le moment que sous Unix ...
;
; --------------------------------------
;
; Historique des modifications:
;
; --------------------------------------
;-
function AC_FINDFILE, filtre, count=count, verbose=verbose, $
                      debug=debug, test=test, help=help
;
mess=AC_SETMESSAGES('AC_FINDFILE')
;
if (N_PARAMS() lt 1) then begin
    print, mess.fatal+'missing arguments'
    help=1
endif
;
if KEYWORD_SET(help) then begin
    print, 'function AC_FINDFILE, filtre, count=count, verbose=verbose, $'
    print, '                      debug=debug, test=test, help=help'
    return, -1
endif
;
; si la variable systeme n'est pas activee, il faut le faire !
DEFSYSV, '!software', exist=flag_init
if (flag_init EQ 0) then AC_IDL_OR_GDL
;
; bon, si on est en IDL, on ne se casse pas la tete
;
if (!software EQ 'idl') then begin
    return, FINDFILE(filtre, count=count)
endif
;
; par contre, en GDL, on substitue (fonctionnalites limitees)
;
; par defaut on suppose que l'on a le SHELL "sh" range dans /bin
;
SPAWN, ["/bin/sh", "-c", "ls "+filtre], resultat, /noshell
print, resultat
;
info_resultat=SIZE(resultat)
if (info_resultat(0) EQ 0) then begin
    count=0
endif else begin
    count=N_ELEMENTS(resultat)
endelse
;
if KEYWORD_SET(verbose) then begin
    print, mess.info+'Filter was: ... <<',filtre,'>>'
    if (count GT 0) then begin
        print, mess.info+'Number of founded elements:', count
        print, mess.info+'Values are:', resultat
    endif else begin
        print, mess.warning+'Nothing founded !'
    endelse
endif
;
if KEYWORD_SET(debug) then begin
    HELP
endif
;
if KEYWORD_SET(test) then STOP
;
return, resultat
;
end
;
