;
; AC, cree le 12/02/2002
;
; AC_GETDIR: cette fonction retourne le nom complet du repertoire courant,
; pour simplification nmemonique !
;
; Par default, on ajoute le separateur final (/,\,:) du systeme,
; ce qui correspond a 99% de l'usage. Sinon, /no_final_sep
;
; -------------------------------
; NB: AC le 17/08/04 : apres echange avec MG, possibilite
;     de recuperer le separateur par separateur=PATH_SEP()
;
; -------------------------------
; Histotique des modifications:
;
; Creation par AC le 12/02/2002
; Reprise pas AC le 19/05/2005
; - ceci marche qlq soit le systeme
; - ajout du mot-clef /no_final_sep pour ne pas ajouter le separateur final
;
; -------------------------------
;
function AC_GETDIR, no_final_sep=no_final_sep, $
                    help=help, test=test, verbose=verbose
;
mess=AC_SETMESSAGES("AC_GETDIR")
;
if KEYWORD_SET(help) then begin
    print, 'function AC_GETDIR, no_final_sep=no_final_sep, $'
    print, '                    help=help, test=test, verbose=verbose'
    print, ''
    print, 'function AC_GETDIR returns full path name of current directory'
    print, 'This function should work for all "!version.os_family" (MacOS, Windows, unix)'
    print, ' '
    print, 'CALLING SEQUENCE : chemin=AC_GETDIR()'
    return, -1
endif
;
cd, '.', current=directory
;
; AC le 19/05/2005 : on utilise la fonction PATH_SEP() fournie par IDL
; AC le 19/05/2005 : on supprime STRCOMPRESS(directory,/remove_all)
; qui poserait probleme si "espace" present, non ? 
; (je me demande pourquoi ceci existait !)  
;
; Par defaut, on ajoute un separateur final
;
if NOT(KEYWORD_SET(no_final_sep)) then begin
    ;; directory=STRCOMPRESS(directory+PATH_SEP(),/remove_all)
    directory=directory+PATH_SEP()
endif
;
if KEYWORD_SET(verbose) then begin
    print, mess.info+'Current PATH: ', directory
endif
;
if KEYWORD_SET(test) then STOP
;
return, directory
;
end
