;
; Creation par AC le 29/05/2003 a Paris
;
; Ce programme a pour but de retourner directement un tableau a 2 valeurs
; avec les indices I/J du maximum de l'image ...
;
; Historique des modifications:
;
function AC_MAX2IJ, image, bavard=bavard, $
                    debug=debug, test=test, help=help
;
mess=AC_SETMESSAGES('AC_MAX2IJ')
;
if (N_PARAMS() lt 1) then begin
    print, mess.fatal+'missing arguments'
    print, 'function AC_MAX2IJ, image, bavard=bavard, $'
    print, '               debug=debug, test=test, help=help'
    return, -1
endif
;
if KEYWORD_SET(help) then begin
    print, 'function AC_MAX2IJ, image, bavard=bavard, $'    
    print, '               debug=debug, test=test, help=help'
    print,'tab(i,j)=AC_MAX2IJ(image) returns the [i,j] index of Image Max'
    return, -1
endif
;
info_image=SIZE(image)
if (info_image(0) NE 2) then begin
    print, mess.fatal+'Only 2D images can now be processing'
    STOP
    return, -1
endif
;
max_val=MAX(image, indice_max, /NaN)
;
; on recupere l'indice 1D du max
;
nbp_x=info_image(1)
nbp_y=info_image(2)
ij_resultat=INDEX2IJ(indice_max, [nbp_x,nbp_y])
;
; comme MAX ne retourne que l'indice de la premiere occurence du Max,
; on teste quand meme s'il n'y avait pas plus d'une fois cette valeur!
;
liste_max_val=WHERE(image EQ max_val)
if (N_ELEMENTS(liste_max_val) GT 1) then begin
    print, mess.warning+' Max value was found several time in Image'
    print, TRANSPOSE(INDEX2IJ(liste_max_val, [nbp_x,nbp_y]))
endif
;
if KEYWORD_SET(bavard) then begin
    txt='['+STRING(ij_resultat(0))+','
    txt=txt+STRING(ij_resultat(1))+'] is : ...'+STRING(max_val)
    print, mess.info+STRCOMPRESS(txt)
endif
;
if KEYWORD_SET(debug) then begin
    HELP
endif
;
if KEYWORD_SET(test) then STOP
;
return, REFORM(ij_resultat)
;
end
;
