;
; AC le 21/11/2005 a Paris
;
; Ce programme permet de choisir interactivement un fichier
; Si un nom de fichier est fourmis en entree, on verifie que tout va
; bien, sinon on passe en mode interactif
;
; ---------------------------------------------
; Liste des modifications
;
; AC le 14/12/2005: On s'assure que le dernier caractere de PATH est
; bien un !Path_Sep (sinon on ne peut pas concatener !). Au besoin, on
; change Path (globalement !)
;
; ---------------------------------------------
;
; Si la selection reussit (ou si un fichier existe), alors on retourne
; "1", sinon "-1" (a developper ensuite si besoin)
;
function AC_SELECTFILE, filename=filename, path=path, $
                        prefixe=prefixe, suffixe=suffixe, $
                        verbose=verbose, debug=debug, test=test, help=help
;
mess=AC_SETMESSAGES('AC_SELECTFILE')
;
; si le mot-clef /help est active, on retourne l'aide et on sort
;
if KEYWORD_SET(help) then begin
    print, 'function AC_SELECTFILE, filename=filename, path=path, $'
    print, '                        prefixe=prefixe, suffixe=suffixe, $'
    print, '                        verbose=verbose, debug=debug, test=test, help=help'
    return, -1
endif
;
; AC 21/05/2005 : we do not manage fully the PATH now
;
if N_ELEMENTS(path) EQ 0 then begin
    path=''
    ;;    path='Data'+!path_sep
    ;;    print, mess.info+'Default Path: ./', path
endif else begin
    ;; AC le 14/12/05
    ;; il FAUT que le dernier element de PATH soit !path_sep
    if NOT (STRLEN(path)-1 EQ STRPOS(path,!path_sep,/reverse_search)) then begin
        path=path+!path_sep
    endif
endelse
;
interactif=0
;
if N_ELEMENTS(prefixe) EQ 0 then prefixe=''
if N_ELEMENTS(suffixe) EQ 0 then suffixe=''
;
; si un nom de fichier est fournit, on peut retourner OK
; si ce fichier est present
;
if N_ELEMENTS(filename) EQ 1 then begin
    rep=AC_FINDFILE(path+filename, count=nb_files)
    if (nb_files EQ 1) then begin
        ;; on a trouve un et un seul fichier
        if KEYWORD_SET(verbose) then print, mess.info+'file founded'
        return, 1 
    endif else begin
        ;; on n'a pas trouve le fichier
        if KEYWORD_SET(verbose) then print, mess.info+'file NOT founded'
        interactif=1
    endelse
endif
;
if (N_ELEMENTS(filename) EQ 0) OR (interactif EQ 1) then begin
    liste_names=AC_FINDFILE(path+prefixe+'*'+suffixe, count=nb_files)
    if (nb_files LE 0) then begin
        print, mess.fatal+'No file founded in default directory'
        if KEYWORD_SET(test) then STOP
        return, -1
    endif else begin
        liste_names=AC_STR_REMOVE(liste_names, path, /at_begin)
        reponse=AC_WMENU(['Fichiers',liste_names,'Quit'], title=0, init=1)
        if (reponse EQ nb_files+1) then begin
            print, mess.warning+'No file selected in default directory'
            return, -1
        endif else begin
            filename=liste_names(reponse-1)
        endelse
    endelse
endif
;
if KEYWORD_SET(test) then STOP
;
return, 1
end
