;
; Creation par AC le 19/12/2006 a Paris
;
; ----------------------------------------
; Purpose:
;
; Dans une chaine de caracteres, ou un tableaux de chaines,
; compte le nombre d'occurences d'un caractere ou d'une chaine
; de caracteres.
; 
; ----------------------------------------
; Known Limitations (and Bugs):
;
; Attention: alors que STRSPLIT ne peut pas gerer un tableau
; de STRING, ici, nous le faisons, tout en utilisant ligne
; par ligne STRSPLIT
;
; ----------------------------------------
; Historique des modifications:
;
; AC le //06:
; --
;
; ----------------------------------------
; Usage: 
; 
; nb_occurs=AC_STR_COUNT(tab_str, le(s)_caractere(s))
;
; ----------------------------------------
;
function AC_STR_COUNT, tab_texte, element, verbose=verbose, $
                       debug=debug, test=test, help=help
;
mess=AC_SETMESSAGES('AC_STR_COUNT')
;
if (N_PARAMS() lt 2) then begin
    print, mess.fatal+'missing arguments'
    help=1
endif
;
if KEYWORD_SET(help) then begin
    print, 'function AC_STR_COUNT, tab_texte, element, verbose=verbose, $'
    print, '             debug=debug, test=test, help=help'
    return, -1
endif
;
nb_lines=N_ELEMENTS(tab_texte)
resultat=INTARR(nb_lines)
;
;;AC le 19/12/05 : l'idee triviale ne marche pas !
;; resultat(ii)=N_ELEMENTS(STRSPLIT(tab_texte(ii),element,/extract))
;
; Comme on ne sait pas faire la comparaison directe,
; alors on passe en type Byte ...
; (idee issue du programme REPCHR.pro
; http://idlastro.gsfc.nasa.gov/ftp/pro/jhuapl/repchr.pro)
;
ByteElement=BYTE(element)
;
for ii=0, nb_lines-1 do begin
    ligne=BYTE(tab_texte(ii))
    indices=WHERE(ligne EQ ByteElement[0], nbp)
    resultat(ii)=nbp
endfor
;
if KEYWORD_SET(debug) then begin
    HELP
endif
;
if KEYWORD_SET(test) then STOP
;
return, resultat
;
end
;
