;
; AC 06/06/2000
; Retire toutes les occurences du STRING2 dans le STRING1
; (STRING1 est eventuellement un tableau, c'est gere)
;
; AC 01/06/2001 in NY
; -ajout des options (tres utiles) at_begin, at_end et all
;
function AC_STR_REMOVE, tab_string1, string2, all=all, $
                        at_begin=at_begin, at_end=at_end, absolut=absolut, $
                        TEST=TEST, DEBUG=debug, HELP=HELP
;
mess=AC_SETMESSAGES('AC_STR_REMOVE')
;
if KEYWORD_SET(help) then begin
    print, 'function AC_STR_REMOVE, tab_string1, string2, all=all, $'
    print, '                        at_begin=at_begin, at_end=at_end, absolut=absolut, $' 
    print, '                        TEST=TEST, DEBUG=debug, HELP=HELP'
    print, 'this function remove any occurence of "string2" in "tab_string1"'
    print, 'the explicit options are /all, /at_end, /at_begin'
    print, 'when /at_end or /at_begin must affect only "absolut" first and last occurence,'
    print, 'option /absolut must be used.'
endif
;
if (N_PARAMS() lt 2) then begin
    print, mess.fatal+'missing arguments.'
    print, 'function AC_STR_REMOVE, tab_string1, string2, all=all, $'
    print, '                        at_begin=at_begin, at_end=at_end, absolut=absolut, $' 
    print, '                        test=test, debug=debug, help=help'
    return, tab_string1
endif
;
if NOT(KEYWORD_SET(all)) AND NOT(KEYWORD_SET(at_begin)) AND NOT(KEYWORD_SET(at_end)) then begin
    print, mess.warning+'no mandatory keyword provided, nothing was done.'
    return, tab_string1   
endif  
;
; remarque : on peut combiner les keywors /at_end et /at_begin
;
if (KEYWORD_SET(all) AND KEYWORD_SET(at_begin)) then begin
    print, mess.warning+'two contraditory options (/all, /at_begin), nothing was done.'
    return, tab_string1   
endif
if (KEYWORD_SET(all) AND KEYWORD_SET(at_end)) then begin
    print, mess.warning+'two contraditory options (/all, /at_end), nothing was done.'
    return, tab_string1   
endif
;
string_out=tab_string1
;
for i=0, (N_ELEMENTS(tab_string1)-1) do begin
    temp_str=tab_string1(i)
    split_temp_str=STR_SEP(temp_str,string2)
    nb_split=N_ELEMENTS(split_temp_str)
    if (nb_split GT 1) then begin
        if KEYWORD_SET(all) then begin
            intercalaires=REPLICATE('',nb_split-1)
        endif else begin
            intercalaires=REPLICATE(string2,nb_split-1)
            if KEYWORD_SET(at_begin) then begin
                if KEYWORD_SET(absolut) then begin
                    if (split_temp_str(0) EQ '') then intercalaires(0)=''
                endif else begin
                    intercalaires(0)=''
                endelse
            endif
            if KEYWORD_SET(at_end) then begin
                if KEYWORD_SET(absolut) then begin
                    if (split_temp_str(nb_split-1) EQ '') then begin
                        intercalaires(nb_split-2)=''
                    endif
                endif else begin
                    intercalaires(nb_split-2)=''
                endelse
            endif
        endelse
        desplit_temp_str=split_temp_str(0)
        for j=1, (nb_split-1) do begin
            desplit_temp_str=desplit_temp_str+intercalaires(j-1)
            desplit_temp_str=desplit_temp_str+split_temp_str(j)
        endfor
        string_out(i)=desplit_temp_str
    endif
endfor
;
if KEYWORD_SET(debug) then begin
    print, 'Initial String: ........... ', tab_string1
    print, 'To be removed String: ..... ', string2
    print, 'Final String: ............. ', string_out
    print, 'Number of splitting blocks. ', nb_split
    for i=0,(nb_split-1) do print, split_temp_str(i)+'*'
endif
;
if KEYWORD_SET(test) then STOP
;
return, string_out
;
end
