;
; Creation par AC le 03/04/2004 a Meudon (chants finlandais !)
;
; AC le 02/05/2005: "valeur" can be only a singel number (not an array)
;
; Definition: 
; Cette fonction verifie si la valeur fournit est bien
; dans le domaine prevu. Ce dommaine peut etre :
;         simplement borne (min_valeur OU max_valeur)
; ou bien doublement borne (min_valeur ET max_valeur)
; Si la valeur est dans le domaine, on retourne 0 (faux)
; Si la valeur N'est PAS dans le domaine, on retourne 1 (vrai)
; Si il y a un probleme (par exemple pas de borne, ou bien max < min),
; on retourne -1 (qui est aussi un faux)
;
; Historique des modifications:
;
function OUT_OF_RANGE, valeur, min_valeur=min_valeur, max_valeur=max_valeur, $
                       message, bavard=bavard, $
                       debug=debug, test=test, help=help
;
mess=AC_SETMESSAGES('OUT_OF_RANGE')
;
if (N_PARAMS() lt 2) then begin
    print, mess.fatal+'missing arguments'
    help=1
endif
;
if KEYWORD_SET(help) then begin
    print, 'function OUT_OF_RANGE, valeur, min_valeur=min_valeur, max_valeur=max_valeur, $'
    print, '                       message, bavard=bavard, $'
    print, '                       debug=debug, test=test, help=help'
    return, -1
endif
;
; lesquelles des 2 bornes sont presentes (au moins 1 des 2 doit etre presente)
;
min_is_set=0
if (N_ELEMENTS(min_valeur) EQ 1) then min_is_set=1
;
max_is_set=0
if (N_ELEMENTS(max_valeur) EQ 1) then max_is_set=1
;
; cas ou on a aucune des 2 bornes d'indiquees !
;
if ((min_is_set EQ 0) AND (max_is_set EQ 0)) then begin
    print, mess.fatal+"At least one bound must be provide (min_valeur OR max_valeur)"
    return, -1
endif
;
if ((min_is_set EQ 1) AND (max_is_set EQ 1)) then begin
    ;;
    ;; dans le cas ou les bornes sont la, on verifie d'abord
    ;; que les bornes sont bien dans l'ordre ...
    ;;
    if (min_valeur GE max_valeur) then begin
        print, mess.fatal+" Min_Valeur MUST BE LOWER than Max_Valeur !"
        return, -1
    endif else begin
        if (valeur LT min_valeur) OR (valeur GT max_valeur) then begin
            print, message+" used value is out of usual range"
            txt=" Min: "+STRING(min_valeur)+", Valeur: "
            txt=txt+STRING(valeur)+", Max: "+STRING(max_valeur)
            print, message+STRCOMPRESS(txt)
            return, 1
        endif else begin
            return, 0
        endelse
    endelse
endif else begin
    ;;
    ;; desormais, une seule des 2 bornes est presente
    ;;
    if (min_is_set EQ 1) then begin
        if (valeur LT min_valeur) then begin
            print, message+" used value is out of usual range"
            txt=" Min: "+STRING(min_valeur)+", Valeur: "+STRING(valeur)
            print, message+STRCOMPRESS(txt)
            return, 1
        endif else begin
            return, 0
        endelse
    endif
    if (max_is_set EQ 1) then begin
        if (valeur GT max_valeur) then begin
            print, message+" used value is out of usual range"
            txt=" Max: "+STRING(max_valeur)+", Valeur: "+STRING(valeur)
            print, message+STRCOMPRESS(txt)
            return, 1
        endif else begin
            return, 0
        endelse
    endif
endelse
;
; a priori, on arrive jamais ici !
;
if KEYWORD_SET(debug) then begin
    HELP
    STOP
endif
;
if KEYWORD_SET(test) then STOP
;
end
;
