;
; AC 02/05/2005
;
; This program helps to check wether computation for
; basic cases go is the good direction
;
; Tests elementaires de consistance !
;
pro TEST_BASIC, nbp=nbp, test=test, noise=noise
;
mess=AC_SETMESSAGES('TEST_BASIC')
;
; on ferme toutes les fenetres actives afin que
; la succession des traces soit claire !
;
AC_RESET
;
; selection interactive d'un bolo
;
bolo=LIST_BOLO_SELECT()
if (N_TAGS(bolo) LE 0) then begin
    print, mess.fatal+'No selected bolo !'
    return
endif
;
if (N_ELEMENTS(nbp) EQ 0) then nbp=1e4
;
; creation du signal incident
;
op=CREATE_OPT_SIGNAL(delta_t=1e-4, nbp=nbp, /beam, amp=2.7e-13, /center)
; we add a background
op=op+3.8e-13
;
; ajour eventuel du bruit
;
if (N_ELEMENTS(noise) GT 0) then op=op+noise*RANDOMN(seed,nbp)
;
; ----------------------------------------
;
; 1er test: il s'agit de verifier que, pour un meme signal incident,
; et pour 3 temperatures de la platine 0.1 mK,
; les 3 calculs sont bien dans le bon sens
;
t1a=BOLO_DIRECT_MODEL(op, bolo=bolo, t_bath=.10)
t1b=BOLO_DIRECT_MODEL(op, bolo=bolo, t_bath=.11)
t1c=BOLO_DIRECT_MODEL(op, bolo=bolo, t_bath=.12)
;
plot, t1c, /ynoze, /nodata
oplot, t1c, col=!col.r
XYOUTS, AC_XYOUTS(0.8, /X), AC_XYOUTS(0.3, /Y), 'Tbath=.12', colo=!col.r
oplot, t1b, col=!col.y
XYOUTS, AC_XYOUTS(0.8, /X), AC_XYOUTS(0.2, /Y), 'Tbath=.11', colo=!col.y
oplot, t1a, col=!col.g
XYOUTS, AC_XYOUTS(0.8, /X), AC_XYOUTS(0.1, /Y), 'Tbath=.10', colo=!col.g
;
AC_DELAIS
;
; ----------------------------------------
; 2eme test : cas de la variation de la temperature
; de la platine 100 mK
; on genere une rampe de temperature (de 0.1 a 0.2 K)
;
nbp=N_ELEMENTS(op)
tb=0.1+0.1*findgen(nbp)/nbp
t=BOLO_DIRECT_MODEL(op, bolo=bolo, t_bath=tb)
op2=BOLO_INVERT_MODEL(t, bolo=bolo, t_bath=tb)
;
window, 0, title='Temperatures'
plot, tb, title='Bolometer Temperatures'
oplot, t, color=!col.g
XYOUTS, AC_XYOUTS(0.8, /X), AC_XYOUTS(0.1, /Y), 'T bath'
XYOUTS, AC_XYOUTS(0.8, /X), AC_XYOUTS(0.2, /Y), $
  'T bolo', color=!col.g
;
window, 1, title='Incoming Optical Signal'
plot, op, title='Incoming Optical Signal', $
  xtitle='time', ytitle='Watt'
oplot, op2, color=!col.r
XYOUTS, AC_XYOUTS(0.8, /X), AC_XYOUTS(0.1, /Y), 'Incoming signal'
XYOUTS, AC_XYOUTS(0.8, /X), AC_XYOUTS(0.2, /Y), $
  'Reconstructed signal', color=!col.r
;
;AC_DELAIS
;
; ----------------------------------------
; 3eme test : cas de signaux optiques creneaux
; Les constantes de temps d'apres M Piat sont-elles OK ?
; 
print, mess.info, 'Test on Steps not ready now (can be include here)'
print, mess.info, 'Please also consider program TEST_TIME_CONST'
;
if KEYWORD_SET(test) then STOP
;
end
